/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
//
//  NOTE!: This file is autogenerated - do not modify!
//         if you need to make a change, please see the Groovy scripts in the
//         activemq-core module
//


using Apache.NMS.ActiveMQ.State;

namespace Apache.NMS.ActiveMQ.Commands
{
	/// <summary>
	///  The ActiveMQ DestinationInfo Command
	/// </summary>
	public class DestinationInfo : BaseCommand
	{
		public const byte ID_DestinationInfo = 8;

		public const byte ADD_OPERATION_TYPE = 0;
		public const byte REMOVE_OPERATION_TYPE = 1;

		ConnectionId connectionId;
		IDestination destination;
		byte operationType;
		long timeout;
		BrokerId[] brokerPath;

		public override string ToString()
		{
			return GetType().Name + "["
				+ " ConnectionId=" + ConnectionId
				+ " Destination=" + Destination
				+ " OperationType=" + OperationType
				+ " Timeout=" + Timeout
				+ " BrokerPath=" + BrokerPath
				+ " ]";

		}

		public override byte GetDataStructureType()
		{
			return ID_DestinationInfo;
		}


		// Properties

		public ConnectionId ConnectionId
		{
			get { return connectionId; }
			set { this.connectionId = value; }
		}

		public IDestination Destination
		{
			get { return destination; }
			set { this.destination = value; }
		}

		public byte OperationType
		{
			get { return operationType; }
			set { this.operationType = value; }
		}

		public long Timeout
		{
			get { return timeout; }
			set { this.timeout = value; }
		}

		public BrokerId[] BrokerPath
		{
			get { return brokerPath; }
			set { this.brokerPath = value; }
		}

		public bool IsAddOperation
		{
			get
			{
				return OperationType == ADD_OPERATION_TYPE;
			}
		}

		public bool IsRemoveOperation
		{
			get
			{
				return OperationType == REMOVE_OPERATION_TYPE;
			}
		}

		public override Response visit(ICommandVisitor visitor)
		{
			if(IsAddOperation)
			{
				return visitor.processAddDestination(this);
			}
			else if(IsRemoveOperation)
			{
				return visitor.processRemoveDestination(this);
			}
			throw new IOException("Unknown operation type: " + OperationType);
		}
	}
}
