/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
//
//  NOTE!: This file is autogenerated - do not modify!
//         if you need to make a change, please see the Groovy scripts in the
//         activemq-core module
//


using Apache.NMS.ActiveMQ.State;

namespace Apache.NMS.ActiveMQ.Commands
{
	/// <summary>
	///  The ActiveMQ ProducerInfo Command
	/// </summary>
	public class ProducerInfo : BaseCommand
	{
		public const byte ID_ProducerInfo = 6;

		ProducerId producerId;
		ActiveMQDestination destination;
		BrokerId[] brokerPath;
		bool dispatchAsync;

		public override string ToString()
		{
			return GetType().Name + "["
				+ " ProducerId=" + ProducerId
				+ " Destination=" + Destination
				+ " BrokerPath=" + BrokerPath
				+ " DispatchAsync=" + DispatchAsync
				+ " ]";

		}

		public override byte GetDataStructureType()
		{
			return ID_ProducerInfo;
		}


		// Properties

		public ProducerId ProducerId
		{
			get { return producerId; }
			set { this.producerId = value; }
		}

		public ActiveMQDestination Destination
		{
			get { return destination; }
			set { this.destination = value; }
		}

		public BrokerId[] BrokerPath
		{
			get { return brokerPath; }
			set { this.brokerPath = value; }
		}

		public bool DispatchAsync
		{
			get { return dispatchAsync; }
			set { this.dispatchAsync = value; }
		}

		public override Response visit(ICommandVisitor visitor)
		{
			return visitor.processAddProducer(this);
		}
	}
}
