/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
//
//  NOTE!: This file is autogenerated - do not modify!
//         if you need to make a change, please see the Groovy scripts in the
//         activemq-core module
//


using Apache.NMS.ActiveMQ.State;

namespace Apache.NMS.ActiveMQ.Commands
{
	/// <summary>
	///  The ActiveMQ RemoveInfo Command
	/// </summary>
	public class RemoveInfo : BaseCommand
	{
		public const byte ID_RemoveInfo = 12;

		DataStructure objectId;

		public override string ToString()
		{
			return GetType().Name + "["
				+ " ObjectId=" + ObjectId
				+ " ]";

		}

		public override byte GetDataStructureType()
		{
			return ID_RemoveInfo;
		}


		// Properties

		public DataStructure ObjectId
		{
			get { return objectId; }
			set { this.objectId = value; }
		}

		public override Response visit(ICommandVisitor visitor)
		{
			switch(objectId.GetDataStructureType())
			{
				case ConnectionId.ID_ConnectionId:
					return visitor.processRemoveConnection((ConnectionId) objectId);
				case SessionId.ID_SessionId:
					return visitor.processRemoveSession((SessionId) objectId);
				case ConsumerId.ID_ConsumerId:
					return visitor.processRemoveConsumer((ConsumerId) objectId);
				case ProducerId.ID_ProducerId:
					return visitor.processRemoveProducer((ProducerId) objectId);
				default:
					throw new IOException("Unknown remove command type: " + objectId.GetDataStructureType());
			}
		}
	}
}
